// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package freeje_admin

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// BackupClient is the client API for Backup service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type BackupClient interface {
	//
	// Запрашивает поток элементов резервной копии с заданными типами
	CreateBackup(ctx context.Context, in *BackupOptions, opts ...grpc.CallOption) (Backup_CreateBackupClient, error)
	LoadBackup(ctx context.Context, opts ...grpc.CallOption) (Backup_LoadBackupClient, error)
}

type backupClient struct {
	cc grpc.ClientConnInterface
}

func NewBackupClient(cc grpc.ClientConnInterface) BackupClient {
	return &backupClient{cc}
}

func (c *backupClient) CreateBackup(ctx context.Context, in *BackupOptions, opts ...grpc.CallOption) (Backup_CreateBackupClient, error) {
	stream, err := c.cc.NewStream(ctx, &Backup_ServiceDesc.Streams[0], "/com.freeje.api.admin.Backup/CreateBackup", opts...)
	if err != nil {
		return nil, err
	}
	x := &backupCreateBackupClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Backup_CreateBackupClient interface {
	Recv() (*BackupEntity, error)
	grpc.ClientStream
}

type backupCreateBackupClient struct {
	grpc.ClientStream
}

func (x *backupCreateBackupClient) Recv() (*BackupEntity, error) {
	m := new(BackupEntity)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *backupClient) LoadBackup(ctx context.Context, opts ...grpc.CallOption) (Backup_LoadBackupClient, error) {
	stream, err := c.cc.NewStream(ctx, &Backup_ServiceDesc.Streams[1], "/com.freeje.api.admin.Backup/LoadBackup", opts...)
	if err != nil {
		return nil, err
	}
	x := &backupLoadBackupClient{stream}
	return x, nil
}

type Backup_LoadBackupClient interface {
	Send(*BackupEntity) error
	CloseAndRecv() (*BackupResult, error)
	grpc.ClientStream
}

type backupLoadBackupClient struct {
	grpc.ClientStream
}

func (x *backupLoadBackupClient) Send(m *BackupEntity) error {
	return x.ClientStream.SendMsg(m)
}

func (x *backupLoadBackupClient) CloseAndRecv() (*BackupResult, error) {
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	m := new(BackupResult)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// BackupServer is the server API for Backup service.
// All implementations should embed UnimplementedBackupServer
// for forward compatibility
type BackupServer interface {
	//
	// Запрашивает поток элементов резервной копии с заданными типами
	CreateBackup(*BackupOptions, Backup_CreateBackupServer) error
	LoadBackup(Backup_LoadBackupServer) error
}

// UnimplementedBackupServer should be embedded to have forward compatible implementations.
type UnimplementedBackupServer struct {
}

func (UnimplementedBackupServer) CreateBackup(*BackupOptions, Backup_CreateBackupServer) error {
	return status.Errorf(codes.Unimplemented, "method CreateBackup not implemented")
}
func (UnimplementedBackupServer) LoadBackup(Backup_LoadBackupServer) error {
	return status.Errorf(codes.Unimplemented, "method LoadBackup not implemented")
}

// UnsafeBackupServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to BackupServer will
// result in compilation errors.
type UnsafeBackupServer interface {
	mustEmbedUnimplementedBackupServer()
}

func RegisterBackupServer(s grpc.ServiceRegistrar, srv BackupServer) {
	s.RegisterService(&Backup_ServiceDesc, srv)
}

func _Backup_CreateBackup_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(BackupOptions)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(BackupServer).CreateBackup(m, &backupCreateBackupServer{stream})
}

type Backup_CreateBackupServer interface {
	Send(*BackupEntity) error
	grpc.ServerStream
}

type backupCreateBackupServer struct {
	grpc.ServerStream
}

func (x *backupCreateBackupServer) Send(m *BackupEntity) error {
	return x.ServerStream.SendMsg(m)
}

func _Backup_LoadBackup_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(BackupServer).LoadBackup(&backupLoadBackupServer{stream})
}

type Backup_LoadBackupServer interface {
	SendAndClose(*BackupResult) error
	Recv() (*BackupEntity, error)
	grpc.ServerStream
}

type backupLoadBackupServer struct {
	grpc.ServerStream
}

func (x *backupLoadBackupServer) SendAndClose(m *BackupResult) error {
	return x.ServerStream.SendMsg(m)
}

func (x *backupLoadBackupServer) Recv() (*BackupEntity, error) {
	m := new(BackupEntity)
	if err := x.ServerStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// Backup_ServiceDesc is the grpc.ServiceDesc for Backup service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Backup_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "com.freeje.api.admin.Backup",
	HandlerType: (*BackupServer)(nil),
	Methods:     []grpc.MethodDesc{},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "CreateBackup",
			Handler:       _Backup_CreateBackup_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "LoadBackup",
			Handler:       _Backup_LoadBackup_Handler,
			ClientStreams: true,
		},
	},
	Metadata: "admin/backup.proto",
}
